//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"

const int LOGGER_MAX_STR = 1024;	//	1 ső啶

//	NX
#include "CLogger.h"

/*
 *	fXgN^
 */
CLogger::~CLogger(){
	Clear();
	delete []m_Message;
	delete []m_CopyFlag;
}

/*
 *	
 */
void CLogger::Init(
	int n,	//	ős
	int c,	//	s (sȂ̏ꍇ 0)
	int x,	//	x W
	int y	//	y W
){
	int i;
	m_Number = n;
	m_Message = new char *[n];
	m_CopyFlag = new bool [n];
	for(i = 0; i<m_Number; i++){
		m_Message[i] = NULL;
		m_CopyFlag[i] = false;
	}
	m_Count = 0;
	m_Cycle = c;
	m_PosX = x;
	m_PosY = y;
	m_Interval = FONT_HEIGHT;
}

/*
 *	W̍Đݒ
 */
void CLogger::SetPos(
	int x,	//	x W
	int y	//	y W
){
	m_PosX = x;
	m_PosY = y;
}

/*
 *	sԊu̐ݒ
 */
void CLogger::SetInterval(
	int interval	//	sԊu
){
	m_Interval = interval;
}

/*
 *	e̒ǉ (Rs[͂Ȃ)
 */
void CLogger::Add(
	char *m	//	ǉ
){
	int i;
	if(m_CopyFlag[0]) delete [] m_Message[0];
	for(i = 0; i<(m_Number-1); i++){
		m_Message[i] = m_Message[i+1];
		m_CopyFlag[i] = m_CopyFlag[i+1];
	}
	m_CopyFlag[m_Number-1] = false;
	m_Message[m_Number-1] = m;
	m_Count = 0;
}

/*
 *	t̒ǉ (͕ʓrRs[)
 */
void CLogger::AddF(
	char *f,	//	
	...			//	Cӈ
){
	int i;
	va_list	vl;
	if(m_CopyFlag[0]) delete [] m_Message[0];
	for(i = 0; i<(m_Number-1); i++){
		m_Message[i] = m_Message[i+1];
		m_CopyFlag[i] = m_CopyFlag[i+1];
	}
	m_CopyFlag[m_Number-1] = true;
	m_Message[m_Number-1] = new char[LOGGER_MAX_STR];
	va_start(vl, f);
	vsprintf(m_Message[m_Number-1], f, vl);
	va_end(vl);
	m_Count = 0;
}

/*
 *	̃_O
 */
void CLogger::Show(){
	int i;
	for(i = 0; i<m_Number; i++) Text(m_PosX, m_PosY+i*m_Interval, m_Message[i]);
	if(m_Cycle){
		m_Count++;
		if(m_Count>=m_Cycle) Add("");
	}
}

/*
 *	ȇS
 */
void CLogger::Clear(){
	int i;
	for(i = 0; i<m_Number; i++){
		if(m_CopyFlag[i]) delete [] m_Message[i];
		m_Message[i] = NULL;
		m_CopyFlag[i] = false;
	}
	m_Count = 0;
}
