//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CPierModel.h"

//	OO[o
extern char g_BaseDir[];

//	O[o
int g_PierOptionModels = 0;					//	rvOCo^
int g_PierOptionSelect = 0;					//	Iꂽr̃Xgԍ
CPierModel *g_PierOptionModelSeed = NULL;	//	Xg̐擪
CPierModel *g_PierOptionModelSelect = NULL;	//	Iꂽr
CPierModel **g_PierOptionModelNext = &g_PierOptionModelSeed;
											//	Ō|C^
/*
 *	RXgN^
 */
CPierModel::CPierModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	strcpy(m_Index, str);
	if(m_Loaded = load){
		m_MeshPole.Load("Model1.x");
		m_MeshHead.Load("Model2.x");
	}
	fscanf(info, "%s\n%s\n%f\n%f", m_Name, m_Author, &m_TieWidth, &m_Interval);
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_Interval *= m_Scale;
	m_Next = NULL;
	*g_PierOptionModelNext = this;
	g_PierOptionModelNext = NextAdr();
	m_Count = g_PierOptionModels;
	g_PierOptionModels++;
}

/*
 *	fXgN^
 */
CPierModel::~CPierModel(){
	if(m_Next){
		delete m_Next;
		m_Next = NULL;
	}
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CObject *CPierModel::GetObject(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Pier");
		chdir(m_Index);
		m_MeshPole.Load("Model1.x");
		m_MeshHead.Load("Model2.x");
		m_ObjectPole.SetMesh(&m_MeshPole, V3ZERO, m_Scale);
		m_ObjectHead.SetMesh(&m_MeshHead, V3ZERO, m_Scale);
		m_Loaded = true;
	}
	return &m_ObjectPole;
}
