//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"

//	NX
#include "CPlugin.h"

extern int g_MiscOptionPluginSort;

/*
 *	RXgN^
 */
CPlugin::CPlugin(){
	m_Loaded = false;
}

/*
 *	AXg̎wԍ擾
 *
 *	߂l:	vvOC
 */
CPlugin *CPlugin::GetBase(
	int count	//	ԍ
){
	if(count<0) return NULL;
	CPlugin *ptr = this;
	while(count){
		ptr = ptr->m_Next;
		count--;
	}
	return ptr;
}

/*
 *	w ID ̃vOC
 *
 *	߂l:	vvOC
 */
CPlugin *CPlugin::FindBase(
	char *target	//	 ID
){
	if(_mbsicmp((PUCHAR)target, (PUCHAR)m_Index)){
		if(m_Next) return m_Next->FindBase(target);
		return NULL;
	}
	return this;
}

/*
 *	\[gpr֐
 */
int CPlugin::Compare(
	CPlugin *target	//	rΏۃvOC
){
	int ret;
	switch(g_MiscOptionPluginSort){
	case 0:
		if(ret = _mbsicmp((PUCHAR)(m_Index), (PUCHAR)(target->m_Index))) break;
		if(ret = _mbsicmp((PUCHAR)(m_Name), (PUCHAR)(target->m_Name))) break;
		ret = _mbsicmp((PUCHAR)(m_Author), (PUCHAR)(target->m_Author));
		break;
	case 1:
		if(ret = _mbsicmp((PUCHAR)(m_Name), (PUCHAR)(target->m_Name))) break;
		if(ret = _mbsicmp((PUCHAR)(m_Index), (PUCHAR)(target->m_Index))) break;
		ret = _mbsicmp((PUCHAR)(m_Author), (PUCHAR)(target->m_Author));
		break;
	case 2:
		if(ret = _mbsicmp((PUCHAR)(m_Author), (PUCHAR)(target->m_Author))) break;
		if(ret = _mbsicmp((PUCHAR)(m_Index), (PUCHAR)(target->m_Index))) break;
		ret = _mbsicmp((PUCHAR)(m_Name), (PUCHAR)(target->m_Name));
		break;
	}
	return ret;
}

/*
 *	vOCXg̕ёւ
 */
void CPlugin::MergeSort(
	CPlugin **seed,	//	Jn|C^
	CPlugin *end,	//	I|C^
	int ofs			//	XgԍItZbg
){
	int num1 = 0, num2 = 0, id = 0;
	CPlugin *ptr = this, *mid = this, *last = this, **carrier = seed;
	while(ptr!=end){
		if(num1>num2){
			num2++;
		}else{
			num1++;
			last = mid;
			mid = mid->m_Next;
		}
		ptr = ptr->m_Next;
	}
	if(num1>1) MergeSort(seed, mid, ofs);
	if(num2>1) mid->MergeSort(&mid, end, ofs+num1);
	CPlugin *adr1 = *seed, *adr2 = mid;
	while(true){
		int *cnt;
		CPlugin **next;
		if(num1){
			if(num2){
				if(adr1->Compare(adr2)<0){
					next = &adr1; cnt = &num1;
				}else{
					next = &adr2; cnt = &num2;
				}
			}else{
				next = &adr1; cnt = &num1;
			}
		}else{
			if(num2){
				next = &adr2; cnt = &num2;
			}else{
				break;
			}
		}
		*carrier = *next;
		carrier = &(*next)->m_Next;
		(*next)->m_Count = ofs+id;
		*next = (*next)->m_Next;
		(*cnt)--;
		id++;
	}
	*carrier = NULL;
}
