class CRailModel;
class CTieModel;
class CPierModel;

/*
 *	[NX
 *
 *	[̃XvCȐ\ŏvf
 */
class CRail{
	friend class CRailList;
private:
	int m_Point[2];				//	|Cgؑ֏ (m_Next ̉ECfbNX)
	int m_User;					//	gpqCfbNX
	int m_Update;				//	|Cg؂ւqCfbNX
	int m_SUpdate;				//	Ot[̃|Cg؂ւqCfbNX
	int m_PierNum;				//	r{
	float m_Start[2];			//	[Jnn_ (EE)
	float m_Length[3];			//	[ (EEE)
	float m_Tie;				//	؊Jnn_
	float m_Pier;				//	rJnn_
	float m_VLine;				//	ːc
	float *m_PHigh;				//	rݒu
	float m_VDist;				//	_̋
	bool m_Selected;			//	ItO
	bool m_HomeAnchor;			//	z[~AJ[ł邩ǂ
	bool m_LineFlag;			//	ː̗L
	VEC3 m_Pos[2];				//	W (JnEI)
	VEC3 m_Normal[2];			//	 (JnEI)
	VEC3 m_Up[3];				//	up xNg (JnEIE)
	VEC3 m_Right[2];			//	right xNg (JnEI)
	VEC3 m_Dir[3];				//	dir xNg (EEE)
	VEC3 m_Mid;					//	SW
	CRailModel *m_RailModel;	//	[vOC
	CTieModel *m_TieModel;		//	؃vOC
	CPierModel *m_PierModel;	//	rvOC
	CRail *m_Next[2][2];		//	ڑ[ (CfbNX: JnEI)
public:
	CRail();
	~CRail();
	CRail **Install(VEC3 *, VEC3 *, VEC3 *, VEC3 *, VEC3 *, VEC3 *);
	float GetRailHeight();
	void TryLink(bool);
	void UnLink(CRail *);
	VEC3 ReadNext(CRail *, VEC3 *);
	void Select();
	void Release();
	bool Delete();
	void EraseUser(int);
	void Show();
	CRail *GetTrainPos(CRail *, VEC3 *, VEC3 *, VEC3 *, VEC3 *, float, int, int);
	int ScanAnchor(VEC3 *, float , float, float *, bool, bool, int, int);
	void SwitchAnchor();
	void SaveData(FILE *);
	CRail *LoadData(FILE *);
};
