//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"

//	c[֐
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStationModel.h"
#include "CStruct.h"
#include "CStation.h"
#include "CStructList.h"
#include "CStationList.h"

//	OO[o
extern CLogger g_GeneralLog;

/*
 *	RXgN^
 */
CStationList::CStationList(
	int n	//	wɍő吔
){
	int i;
	m_TypeName = "w";
	m_Number = n;
	m_Article = (CStruct **)(new CStation *[n]);
	for(i = 0; i<m_Number; i++) m_Article[i] = NULL;
}

/*
 *	Xgɒǉ
 */
void CStationList::Add(
	CStationModel *m,	//	wɃf
	VEC3 *p,			//	W
	VEC3 *d,			//	dir xNg
	VEC3 *u,			//	up xNg
	bool ha				//	AJ[ݒutO
){
	CStation **ptr;
	if(ptr = (CStation **)(FindSlot())){
		FilePushUndo();
		*ptr = new CStation(m, p, d, u, ha);
		g_GeneralLog.AddF("%sݒu܂B", m->m_Name);
	}else{
		g_GeneralLog.Add("ȏwɂݒuł܂!");
	}
}

/*
 *	ۑ
 */
void CStationList::SaveData(
	FILE *df	//	t@C
){
	int i, n = 0;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) n++;
	fprintf(df, "StationClass{\n\tStations=%d\n", n);
	for(i = 0; i<m_Number; i++) if(m_Article[i]) m_Article[i]->SaveData(df);
	fprintf(df, "}\n\n");
}

/*
 *	Ǎ
 */
void CStationList::LoadData(
	FILE *df	//	t@C
){
	int i, n;
	fscanf(df, "StationClass{\n\tStations=%d\n", &n);
	for(i = 0; i<n; i++){
		m_Article[i] = new CStation;
		m_Article[i]->LoadData(df);
	}
	fscanf(df, "}\n\n");
}
