//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CTieModel.h"

//	OO[o
extern char g_BaseDir[];

//	O[o
int g_TieOptionModels = 0;					//	؃vOCo^
int g_TieOptionSelect = 0;					//	Iꂽ؂̃Xgԍ
CTieModel *g_TieOptionModelSeed = NULL;		//	Xg̐擪
CTieModel *g_TieOptionModelSelect = NULL;	//	Iꂽ
CTieModel **g_TieOptionModelNext = &g_TieOptionModelSeed;
											//	Ō|C^
/*
 *	RXgN^
 */
CTieModel::CTieModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	strcpy(m_Index, str);
	if(m_Loaded = load) m_Mesh.Load("Model.x");
	fscanf(info, "%s\n%s\n%f\n%f", m_Name, m_Author, &m_TieWidth, &m_Interval);
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_Interval *= m_Scale;
	m_Next = NULL;
	*g_TieOptionModelNext = this;
	g_TieOptionModelNext = NextAdr();
	m_Count = g_TieOptionModels;
	g_TieOptionModels++;
}

/*
 *	fXgN^
 */
CTieModel::~CTieModel(){
	if(m_Next){
		delete m_Next;
		m_Next = NULL;
	}
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CObject *CTieModel::GetObject(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Tie");
		chdir(m_Index);
		m_Mesh.Load("Model.x");
		m_Object.SetMesh(&m_Mesh, V3ZERO, m_Scale);
		m_Loaded = true;
	}
	return &m_Object;
}
