//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const float TRAIN_MARCH_TSD = 0.001f;	//	q𓮂Œᑬx

const float TRAIN_MARCH_STOP = 6.0f;	//	Փ˔s

//	c[֐
#include "SystemCover.h"
#include "CameraControl.h"

//	NX
#include "CRail.h"
#include "CRailList.h"
#include "CPlugin.h"
#include "CTrainModel.h"
#include "CTrain.h"

//	OO[o
extern int g_MiscOptionShadowFlag;
extern int g_MiscOptionTrainMode;
extern float g_TrainFarDraw;
extern float g_TrainFarHide;
extern CRailList g_RailOptionList;
extern CTrainModel *g_TrainOptionModelSeed;
extern POINT g_AreaPos1;
extern POINT g_AreaPos2;

//	O[o
float g_TrainOptionNearestDist;			//	Iɔ͈͓ōł߂̂̋
CTrain *g_TrainOptionNearest = NULL;	//	ł߂q

VEC3 g_TrainLinkPos;	//	AW
VEC3 g_TrainLinkDir;	//	A

/*
 *	RXgN^
 */
CTrain::CTrain(
	int i	//	Ґԍ
){
	m_Index = i;
}

/*
 *	RXgN^
 */
CTrain::CTrain(
	CTrainModel *m,	//	qf
	bool t,			//	]tO
	int i			//	Ґԍ
){
	m_Model = m;
	m_TurnFlag = t;
	m_Index = i;
	m_Pos[0] = m_Pos[1] = m_Dir = m_Up = V3ZERO;
	m_Object.SetMesh(m->GetMesh(), V3ZERO, m->m_Scale);
}

/*
 *	NbNőI
 */
void CTrain::Select(){
	float td, dist;
	POINT scr;
	VEC3 mid = m_Object.GetPos();
	if(V3Dot(&(mid-GetVPos()), &GetVDir())<0) return;
	scr = WorldToScreen2(&mid);
	td = 5.0f*PTR_2D_SELECT/PointPointDistance(&mid, &GetVPos());
	if((dist = sqrtf(Squ(scr.x-g_AreaPos1.x)+Squ(scr.y-g_AreaPos1.y)))<td){
		if(!g_TrainOptionNearest || g_TrainOptionNearestDist>dist){
			g_TrainOptionNearestDist = dist;
			g_TrainOptionNearest = this;
		}
	}
}

/*
 *	] ON/OFF
 */
void CTrain::Turn(){
	if(m_TurnFlag) m_TurnFlag = false; else m_TurnFlag = true;
}

/*
 *	q̔zuԂmF
 *
 *	߂l: ɔzuł true Ԃ
 */
bool CTrain::GetReady(
	CRail *t,	//	zu[
	bool c,		//	qƂ̏Փ˔tO
	bool r		//	ރtO
){
	float railheight = m_Place[0]->GetRailHeight();
	VEC3 *pp1, *pp2, td;
	V3Norm(&m_Dir, &(m_Pos[0]-m_Pos[1]));
	m_Object.SetPos((m_Pos[0]+m_Pos[1])*0.5f+m_Up*railheight);
	m_Object.SetDir((m_TurnFlag ? m_Dir : -m_Dir), m_Up);
	if(r){
		pp1 = &m_Pos[1];
		pp2 = &m_Pos[0];
		td = -m_Dir;
	}else{
		pp1 = &m_Pos[0];
		pp2 = &m_Pos[1];
		td = m_Dir;
	}
	g_TrainLinkPos = *pp2-m_Model->m_Fix*td;
	g_TrainLinkDir = td;
	if(!t->GetTrainPos(NULL, &td, pp2, NULL, NULL, m_Model->m_Fix, c ? 0x19 : 0x09, m_Index) && c) return false;
	return true;
}

/*
 *	߂l: IuWFNg
 */
CObject *CTrain::GetObject(){
	return &m_Object;
}

/*
 *	zuԂ̔zu
 *
 *	߂l:	ԗւ̔zu[
 */
CRail *CTrain::Set(
	CRail *dest,	//	Oԗւ̔zu[
	VEC3 *d			//	zu
){
	m_Place[0] = dest;
	if(m_Place[1] = dest->GetTrainPos(NULL, d, &m_Pos[0], &m_Pos[1], &m_Up, m_Model->m_TireLength, 0x5a, m_Index)){
		if(!(m_Place[0]->GetTrainPos(NULL, &(-*d), &m_Pos[0], NULL, NULL, m_Model->m_Fix, 0x5d, m_Index))) return NULL;
		if(!GetReady(m_Place[1], true, false)) return NULL;
		return m_Place[1];
	}
	return NULL;
}

/*
 *	s̎qWČvZ
 *
 *	߂l: ԗւ̔zu[
 */
CRail *CTrain::Set2(
	CRail *dest,	//	Oԗւ̔zu[
	VEC3 *d,		//	
	VEC3 *p,		//	W
	bool c,			//	qƂ̏Փ˔tO
	bool r			//	ރtO
){
	VEC3 tp1, tp2, tu, *pp1, *pp2;
	CRail *p1, *p2, **rp1, **rp2;
	if(r){
		pp1 = &m_Pos[1];
		pp2 = &m_Pos[0];
		rp1 = &m_Place[1];
		rp2 = &m_Place[0];
	}else{
		pp1 = &m_Pos[0];
		pp2 = &m_Pos[1];
		rp1 = &m_Place[0];
		rp2 = &m_Place[1];
	}
	if(p1 = dest->GetTrainPos(NULL, d, p, &tp1, NULL, m_Model->m_Fix, c ? 0x59 : 0x09, m_Index)){
		if(p2 = p1->GetTrainPos(NULL, &(*p-tp1), &tp1, &tp2, &tu, m_Model->m_TireLength, c ? 0x59 : 0x09, m_Index)){
			*pp1 = tp1;
			*pp2 = tp2;
			*rp1 = p1;
			*rp2 = p2;
			m_Up = tu;
			if(!GetReady(p2, c, r)) return NULL;
			return p2;
		}
	}
	return NULL;
}

/*
 *	sO[̒T
 *
 *	߂l:	ԗւ̔zu[
 */
CRail *CTrain::March(
	float s,	//	ړ
	float scan,	//	HT
	float *get,	//	i[
	int *test	//	oi[
){
	VEC3 tp1, tp2, tu, td, *pp1, *pp2;
	CRail *p1, *p2, **rp1, **rp2;
	bool ret;
	if(ret = s<0.0f){
		td = -m_Dir;
		pp1 = &m_Pos[1];
		pp2 = &m_Pos[0];
		rp1 = &m_Place[1];
		rp2 = &m_Place[0];
	}else{
		td = m_Dir;
		pp1 = &m_Pos[0];
		pp2 = &m_Pos[1];
		rp1 = &m_Place[0];
		rp2 = &m_Place[1];
	}
	if(fabsf(s)<TRAIN_MARCH_TSD){
		*test = (*rp1)->ScanAnchor(&(-td), 0.0f, scan, get, true, false, 0, m_Index);
		(*rp1)->GetTrainPos(NULL, &(-td), pp1, NULL, NULL, m_Model->m_Fix, 0x09, m_Index);
		p1 = *rp1;
		tp1 = *pp1;
	}else{
		//	qƂ̏Փˌo
		*test = (*rp1)->ScanAnchor(&(-td), 0.0f, scan, get, true, false, 0, m_Index);
		//	OԗւO̕ɂă[U[̏
		if(!(*rp1)->GetTrainPos(NULL, &(-td), pp1, NULL, NULL, s+m_Model->m_Fix, 0x09, m_Index)) return NULL;
		//	Xs[hOɐi܂
		if(!(p1 = (*rp1)->GetTrainPos(NULL, &(-td), pp1, &tp1, NULL, s, 0x0d, m_Index))) return NULL;
	}
	if(p2 = p1->GetTrainPos(NULL, &td, &tp1, &tp2, &tu, m_Model->m_TireLength, 0x09, m_Index)){
		*rp1 = p1;
		*rp2 = p2;
		*pp1 = tp1;
		*pp2 = tp2;
		m_Up = tu;
		GetReady(p2, false, ret);
		return p2;
	}
	return NULL;
}

/*
 *	_O
 */
void CTrain::Show(){
	float ta;
	if(g_MiscOptionTrainMode){
		ta = 1.0f;
	}else{
		ta = GetFarAlpha(&m_Object.GetPos(), g_TrainFarDraw, g_TrainFarHide);
		if(ta==0.0f) return;
	}
	if(g_MiscOptionShadowFlag) RenderShadow2(&m_Object, ta);
	Render2(&m_Object, ta);
}

/*
 *	Ґvr[̕\
 */
void CTrain::Preview(
	VEC3 *p,	//	W
	VEC3 *d,	//	dir xNg
	VEC3 *u		//	up xNg
){
	m_Object.SetPos(*p);
	m_Object.SetDir(m_TurnFlag ? *d : -*d, *u);
	m_Object.Render();
}

/*
 *	ۑ
 */
void CTrain::SaveData(
	FILE *df	//	t@C
){
	fprintf(df, "\t\tTrain{\n\t\t\tModel=%s\n", m_Model->m_Index);
	fprintf(df, "\t\t\tTurn=%d\n", m_TurnFlag);
	fprintf(df, "\t\t\tPos=");
	SaveVec3Data(df, m_Pos[0], ",");
	SaveVec3Data(df, m_Pos[1], "\n");
	fprintf(df, "\t\t\tDir=");
	SaveVec3Data(df, m_Dir, "\n");
	fprintf(df, "\t\t\tUp=");
	SaveVec3Data(df, m_Up, "\n");
	fprintf(df, "\t\t\tPlace=%08X,%08X\n", m_Place[0], m_Place[1]);
	fprintf(df, "\t\t}\n");
}

/*
 *	Ǎ
 */
void CTrain::LoadData(
	FILE *df	//	t@C
){
	char id_str[FILE_NAME_MAX];
	int i;
	fscanf(df, "\t\tTrain{\n\t\t\tModel=%s\n", id_str);
	fscanf(df, "\t\t\tTurn=%d\n", &m_TurnFlag);
	fscanf(df, "\t\t\tPos=");
	LoadVec3Data(df, &m_Pos[0], ",");
	LoadVec3Data(df, &m_Pos[1], "\n");
	fscanf(df, "\t\t\tDir=");
	LoadVec3Data(df, &m_Dir, "\n");
	fscanf(df, "\t\t\tUp=");
	LoadVec3Data(df, &m_Up, "\n");
	fscanf(df, "\t\t\tPlace=%08X,%08X\n", &m_Place[0], &m_Place[1]);
	fscanf(df, "\t\t}\n");
	if(!(m_Model = g_TrainOptionModelSeed->Find(id_str))){
		fclose(df);
		ShowCursor(true);
		Dialog("qvOC \"%s\" sĂ܂!", id_str);
		ExitProcess(0);
	}
	m_Object.SetMesh(m_Model->GetMesh(), V3ZERO, m_Model->m_Scale);
	for(i = 0; i<2; i++) g_RailOptionList.ReLink(&m_Place[i]);
}
