//	Cu
#include <io.h>
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "SystemCover.h"

//	NX
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStationModel.h"
#include "CStructList.h"
#include "CStationList.h"

//	OO[o
extern int g_StationOptionModels;
extern CStationModel *g_StationOptionModelSeed;
extern CStationList g_StationOptionList;
extern char g_BaseDir[];
extern CObject g_OpeningObject[];

//	O[o
int g_PluginOptionStationNumber = 0;	//	wɃvOCo^

//	֐錾
void LogoFrame(int);
void LoadStruct();

/*
 *	wɃvOCǍ
 */
void LoadStation(){
	long filelist;
	_finddata_t data;
	FILE *fname;
	chdir(g_BaseDir);
	chdir("Station");
	if((filelist = _findfirst("*", &data))>=0){
		do{
			chdir(g_BaseDir);
			chdir("Station");
			if(!(data.attrib&_A_SUBDIR)) continue;
			chdir(data.name);
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Station.txt", "r"))) continue;
			g_PluginOptionStationNumber++;
			new CStationModel(data.name, fname, false);
			fclose(fname);
		} while(!_findnext(filelist, &data));
	}
	_findclose(filelist);
	if(g_StationOptionModels){
		g_StationOptionModelSeed->AddLog(0);
		g_StationOptionModelSeed->ViewSpec();
	}else{
		ShowCursor(true);
		Dialog("p\ȉwɂ܂!");
		ExitProcess(0);
	}
	BeginScene();
	LogoFrame(90);
	Text(5, DISP_HEIGHT-5-3*FONT_HEIGHT, "Train ... Complete");
	Text(5, DISP_HEIGHT-5-2*FONT_HEIGHT, "Station ... Complete");
	Text(5, DISP_HEIGHT-5-FONT_HEIGHT, "Struct ... Loading");
	EndScene();
	SetLoopFunc(LoadStruct);
}
