//	Cu
#include <io.h>
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "SystemCover.h"

//	NX
#include "CPlugin.h"
#include "CTrainModel.h"
#include "CTrainGroup.h"
#include "CTrainGroupList.h"

//	OO[o
extern int g_TrainOptionModels;
extern CTrainGroupList g_TrainOptionList;
extern char g_BaseDir[];
extern CObject g_OpeningObject[];

//	O[o
int g_PluginOptionTrainNumber = 0;	//	qvOCo^

//	֐錾
void LogoFrame(int);
void LoadStation();

/*
 *	qvOCǍ
 */
void LoadTrain(){
	long filelist;
	_finddata_t data;
	chdir(g_BaseDir);
	chdir("Train");
	if((filelist = _findfirst("*", &data))>=0){
		do{
			FILE *fname;
			chdir(g_BaseDir);
			chdir("Train");
			if(!(data.attrib&_A_SUBDIR)) continue;
			chdir(data.name);
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Train.txt", "r"))) continue;
			g_PluginOptionTrainNumber++;
			new CTrainModel(data.name, fname, false);
			fclose(fname);
		} while(!_findnext(filelist, &data));
	}
	_findclose(filelist);
	if(g_TrainOptionModels){
		g_TrainOptionList.SetID();
		g_TrainOptionList.GetGroup(0)->SetLog();
	}else{
		ShowCursor(true);
		Dialog("p\Ȏq܂!");
		ExitProcess(0);
	}
	BeginScene();
	LogoFrame(90);
	Text(5, DISP_HEIGHT-5-2*FONT_HEIGHT, "Train ... Complete");
	Text(5, DISP_HEIGHT-5-FONT_HEIGHT, "Station ... Loading");
	EndScene();
	SetLoopFunc(LoadStation);
}
