#include <windows.h>

#define MAKEPIXEL(r, g, b) ((r<<16)|(g<<8)|b)

/*
 *	rbg}bvǗNX
 */
class CPixelbit{
private:
	int m_Width, m_Height;
	DWORD m_ColorKey;
	HBITMAP m_BmpHnd, m_BmpHndOld;
	HDC m_BmpHdc;
	BITMAPINFO m_BmpInfo;
	DWORD *m_PixelAdr;
public:
	CPixelbit();
	CPixelbit(int, int);
	~CPixelbit();
	bool Assign(void *);
	bool Clear(int, int);
	bool Load(char *);
	bool Save(char *);
	int GetWidth();
	int GetHeight();
	HDC GetHDC();
	DWORD GetRGB(int, int);
	DWORD GetBGR(int, int);
	DWORD GetPixel(int, int);
	BYTE GetR(int, int);
	BYTE GetG(int, int);
	BYTE GetB(int, int);
	bool IsColorKey(int, int);
	bool Set4BGR24(int, int, int, int, void *);
	bool Set4BGR32(int, int, int, int, void *);
	bool SetRGB(int, int, DWORD);
	bool SetPixel(int, int, DWORD);
	bool SetR(int, int, int);
	bool SetG(int, int, int);
	bool SetB(int, int, int);
	bool AddR(int, int, int);
	bool AddG(int, int, int);
	bool AddB(int, int, int);
	DWORD GetColorKey();
	bool SetColorKey(DWORD);
	DWORD *GetScanLine(int);
	bool FixLocation(int &, int &, int &, int &, int &, int &, int, int);
	bool WindowStamp(HDC hdcDst, int, int, int, int, int, int);
	bool PlainStamp(CPixelbit *, int, int, int, int, int, int);
	bool HalfStamp(CPixelbit *, int, int, int, int, int, int);
	bool FillRect(int, int, int, int, DWORD);
};

RECT MakeRect(int, int, int, int);
