//	Cu
#include "..\lib\udx.h"

//	萔E}N
#include "..\Const.h"
#include "..\Macro.h"

extern const int MAIN_LOG_MAX;
extern const int TRAIN_LOG_MAX;
extern const int TDIA_LOG_MAX;

const float TRAIN_SPEED_CTRL = 0.5f;	//	xݒԊu

//	c[֐
#include "..\ValueArea.h"
#include "..\SystemCover.h"
#include "..\CameraControl.h"
#include "..\SwitchMode.h"

//	NX
#include "..\CLogger.h"
#include "..\CRailList.h"
#include "..\CPlugin.h"
#include "..\CTrainModel.h"
#include "..\CTrainGroup.h"
#include "..\CTrainGroupList.h"
#include "..\CStructList.h"
#include "..\CStationList.h"

//	OO[o
extern int g_MiscOptionTexFilter;
extern int g_MiscOptionProjectionMode;
extern CRail *g_RailOptionLinkMaster;
extern int g_TrainOptionModels;
extern int g_TrainOptionSelect;
extern int g_TrainOptionListID;
extern int g_TrainOptionIndex;
extern CTrainModel *g_TrainOptionModelSeed;
extern CTrainModel *g_TrainOptionModelSelect;
extern int g_RailSelectFlag;
extern int g_ObjectSelectFlag;
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern float g_Angle;
extern bool g_ModeChanged;
extern bool g_RenderMode;
extern POINT g_Pointer;
extern D3DCOLOR g_SkyColor;
extern VEC3 g_PointPos;
extern VEC3 g_CameraPos;
extern VEC3 g_LinkNormal;
extern CObject g_SurfaceObject;
extern CObject g_TrainDisplayObject;
extern CLogger g_TrainSpecLog;

//	֐錾
void VideoCapture(bool);
void LightSetByAngle(float, float, D3DCOLORVALUE);
void LightShowDir();

/*
 *	qҐ[h
 */
void TrainEdit(){
	static float te_dir = D3DX_PI*1.75f, te_bank = D3DX_PI/6.0f, te_dist = 10.0f;
	static float l_dir = -D3DX_PI*0.25f, l_bank = -D3DXToRadian(54.7356f), l_dist = 10.0f;
	static VEC3 center = V3ZERO;
	bool updatelog = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if(GetButton(DIM_LEFT)>=S_PUSH){
		center += -0.01f*(pos.x-svw.winW/2)*GetVRight()+0.01f*(pos.y-svw.winH/2)*GetVUp();
	}else if(GetButton(DIM_RIGHT)>=S_PUSH){
		if(CheckShift()) CameraRotate(&pos, &l_dir, &l_bank);
		else CameraRotate(&pos, &te_dir, &te_bank);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&te_dist);
	CameraSet(te_dir, te_bank, te_dist, &center, &V3ZERO);
	BeginScene();
	if(GetKey(DIK_HOME)==S_PUSH) center = V3ZERO;
	if(GetKey(DIK_TAB)==S_PUSH) g_RenderMode = !g_RenderMode;
	if(g_RenderMode){
		LightSetByAngle(-l_dir, l_bank, MAKE_CV(0.0f, 0.0f, 0.0f, 1.0f));
		devSetAmbient(0xff202020);
	}else{
		LightSetByAngle(-l_dir, l_bank, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
		devSetAmbient(0xff808080);
	}
	if(GetKey(DIK_SPACE)==S_PUSH) g_MiscOptionTexFilter = 1-g_MiscOptionTexFilter;
	if(g_MiscOptionTexFilter) devTEX_LINEAR(); else devTEX_POINT();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	devSetLighting(true);
	g_TrainDisplayObject.SetPos(V3ZERO);
	g_TrainDisplayObject.SetDir(V3DIR);
	g_TrainDisplayObject.Render();
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(CheckShift()) LightShowDir();
	g_TrainSpecLog.Show();
	TextF(DISP_WIDTH-180, 5, "    ԑ(TAB): %s", g_RenderMode ? "" : "");
	TextF(DISP_WIDTH-180, 5+FONT_HEIGHT, "tB^(SPACE): %s", g_MiscOptionTexFilter ? "`⊮" : "ŋߕ⊮");
	ShowFPS(5, 5);
	EndScene();
}
