//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "SystemCover.h"

//	NX
#include "CInterface.h"

/*
 *	RXgN^
 */
CInterface::CInterface(
	int x,		//	x W
	int y,		//	y W
	int w,		//	
	int h,		//	
	D3DCOLOR c	//	{F
){
	m_Caption = NULL;
	m_PosX = x; m_PosY = y;
	m_Width = w; m_Height = h;
	m_Enabled = true;
	SetColor(c);
}

/*
 *	fXgN^
 */
CInterface::~CInterface(){
	DELETE_A(m_Caption);
}

/*
 *	ANeBuؑ
 */
void CInterface::Enable(
	bool e	//	ANeButO
){
	m_Enabled = e;
}

/*
 *	߂l: ANeButO
 */
bool CInterface::IsEnable(){
	return m_Enabled;
}

/*
 *	F̐ݒ
 */
void CInterface::SetColor(
	D3DCOLOR c	//	{F
){
	int a0, r0, g0, b0;
	SplitColor(&a0, &r0, &g0, &b0, c);
	m_Color = c;
	m_ShadowColor = MAKE_AC(a0, r0*3/4, g0*3/4, b0*3/4);
	m_DarkColor = MAKE_AC(a0, r0/2, g0/2, b0/2);
	m_DarkShadow = MAKE_AC(a0, r0/4, g0/4, b0/4);
}

/*
 *	x\̈̐ݒ
 */
void CInterface::SetCaptionArea(
	int x,	//	x W
	int y,	//	y W
	int w,	//	 (Z^OȂꍇ 0)
	int h	//	 (Z^OȂꍇ 0)
){
	m_CapAreaX = x; m_CapAreaY = y;
	m_CapWidth = w; m_CapHeight = h;
}

/*
 *	x̐ݒ
 */
void CInterface::SetCaption(
	char *s	//	x
){
	DELETE_A(m_Caption);
	m_CapLength = strlen(s);
	strcpy(m_Caption = new char[m_CapLength+1], s);
	m_CapPosX = m_PosX+m_CapAreaX+(m_CapWidth ? (m_CapWidth-FONT_WIDTH*m_CapLength)/2 : 0);
	m_CapPosY = m_PosY+m_CapAreaY+(m_CapHeight ? (m_CapHeight-FONT_HEIGHT)/2 : 0);
}
