//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
/*============================================================================
  pp[^
============================================================================*/
struct PARTICLE_PARAM
{
	float minLife;	//iŏAőj
	float maxLife;
	BYTE minR;		//FiR,G,B,Alphaj
	BYTE maxR;
	BYTE minG;		
	BYTE maxG;
	BYTE minB;
	BYTE maxB;
	BYTE minA;
	BYTE maxA;
	float minAP;	//lω
	float maxAP;
	float minSize;	//TCYiaj
	float maxSize;
	float minSP;	//TCYω
	float maxSP;
	float minV;		//x
	float maxV;
};
/*============================================================================
  ێpp[^
============================================================================*/
struct PARTICLE
{
	float		lifeTime;	//ibj
	float		age;		//Nibj
	BYTE		r;			//R 
	BYTE		g;			//G 
	BYTE		b;			//B 
	float		alpha;		//li0 - 255j
	float		aplus;		//lZʁ^b
	float		size;		//TCYiaj
	float		splus;		//TCYZʁ^b
	VEC3		pos;		//ʒu
	VEC3		vec;		//ړ^b
};
/*============================================================================
  p[eBNG~b^ENX
============================================================================*/
class CParticle
{
	PARTICLE* m_pb;	//qf[^
	VTX_LX*	m_vt;	//_e[u
	int		m_num;	//q
	VEC3	m_pos;	//qʒu
	VEC3	m_gravity;	//d
	float	m_rx[2];//o͈̔
	float	m_ry[2];
	float	m_rz[2];

	//Rs[RXgN^
	CParticle& operator = (const CParticle&){return *this;}
public:

	CParticle();
	~CParticle();
	void Generate(int num,VEC3 pos,PARTICLE_PARAM* pp);
	void Regenerate(PARTICLE_PARAM* pp);
	void Delete();
	BOOL Render();

	/*============================================================================
	  d͂̐ݒ
	============================================================================*/
	void SetGravity(VEC3 g)
	{m_gravity = g;}
	/*============================================================================
	  o͈̔͐ݒ(X)
	============================================================================*/
	void SetXRange(float min,float max)
	{m_rx[0] = min, m_rx[1] = max;}
	/*============================================================================
	  o͈̔͐ݒ(Y)
	============================================================================*/
	void SetYRange(float min,float max)
	{m_ry[0] = min, m_ry[1] = max;}
	/*============================================================================
	  o͈̔͐ݒ(Z)
	============================================================================*/
	void SetZRange(float min,float max)
	{m_rz[0] = min, m_rz[1] = max;}
};