//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
class CSprite
{
	CTexture*	m_pTex;		//eNX`ENX̃IuWFNg
	RECT		m_rect;		//]̋`
	RECT		m_cr;		//蔻`
	VEC2		m_scale;	//XP[
	VEC2		m_center;	//S
	VEC2		m_pos;		//ʒu
	float		m_rot;		//]p
	D3DCOLOR	m_color;	//ZF
	BOOL		m_fRender;	//`tO
	BOOL		m_fTest;	//蔻tO

public:
	CSprite();
	virtual ~CSprite();
	void SetTexture(CTexture* pTex);
	virtual void Render();
	void DrawString(const char* str);
	BOOL CollisionTest(CSprite* pSpr);

	/*============================================================================
	@`tO̐ݒ
	============================================================================*/
	void EnableRender(BOOL f)
	{m_fRender = f;}
	/*============================================================================
	@`tO̎擾
	============================================================================*/
	BOOL IsEnableRender()
	{return m_fRender;}
	/*============================================================================
	@蔻tO̐ݒ
	============================================================================*/
	void EnableTest(BOOL f)
	{m_fTest = f;}
	/*============================================================================
	@蔻tO̎擾
	============================================================================*/
	BOOL IsEnableTest()
	{return m_fTest;}
	/*============================================================================
	@XP[̐ݒ
	============================================================================*/
	void SetScale(VEC2 s)
	{m_scale = s;}
	/*============================================================================
	@XP[̎擾
	============================================================================*/
	VEC2 GetScale()
	{return m_scale;}
	/*============================================================================
	@ʒu̐ݒ
	============================================================================*/
	void SetPos(VEC2 p)
	{m_pos = p;}
	/*============================================================================
	@ʒu̎擾
	============================================================================*/
	VEC2 GetPos()
	{return m_pos;}
	/*============================================================================
	@ړ
	============================================================================*/
	void Move(VEC2 v)
	{m_pos += v;}
	/*============================================================================
	@SW̐ݒ
	============================================================================*/
	void SetCenter(VEC2 c)
	{m_center = c;}
	/*============================================================================
	@SW̎擾
	============================================================================*/
	VEC2 GetCenter()
	{return m_center;}
	/*============================================================================
	@]p̐ݒ
	============================================================================*/
	void SetRot(float r)
	{m_rot = r;}
	/*============================================================================
	@]p̎擾
	============================================================================*/
	float GetRot()
	{return m_rot;}
	/*============================================================================
	@ZF̐ݒ
	============================================================================*/
	void SetColor(D3DCOLOR c)
	{m_color = c;}
	/*============================================================================
	@ZF̎擾
	============================================================================*/
	D3DCOLOR GetColor()
	{return m_color;}
	/*============================================================================
	@]`̐ݒ
	============================================================================*/
	void SetRect(int x1,int y1,int x2,int y2)
	{::SetRect(&m_rect,x1,y1,x2,y2);}
	/*============================================================================
	@]`̎擾
	============================================================================*/
	RECT GetRect()
	{return m_rect;}
	/*============================================================================
	@蔻`̐ݒ
	============================================================================*/
	void SetTestRect(int x1,int y1,int x2,int y2)
	{::SetRect(&m_cr,x1,y1,x2,y2);}
	/*============================================================================
	@蔻`̎擾
	============================================================================*/
	RECT GetTestRect()
	{return m_cr;}
};

void BeginSprite();
void EndSprite();