class CRail;

const int CORNER_MAX = 32;			//	_ő吔
const int RAIL_TIP_MAX = 131072;	//	[`bvő吔

/*
 *	[XgNX
 *
 *	[`bvQ𑩂˂NX
 */
class CRailList{
private:
	int m_Number;							//	_o^
	int m_Oldies;							//	o^ꂽ`bv̐
	float m_TieSpace;						//	ڑ̖؊Jnn_
	float m_PierSpace;						//	ڑ̋rJnn_
	float m_LineSpace;						//	ڑ̉ːcJnn_
	float m_Base[CORNER_MAX];				//	e_ɂn\x
	VEC3 m_Corner[CORNER_MAX];				//	_̍W
	VEC3 m_LinkPos2[2];						//	ڑW (JnEI)
	VEC3 m_LinkNormal2[2];					//	ڑ (JnEI)
	VEC3 m_LinkUp2[2];						//	ڑ up xNg (JnEI)
	CRail *m_Tip[RAIL_TIP_MAX];				//	`bvXg
	CRail **m_LinkFrom2[2];					//	ڑ|C^ (JnEI)
	CRail *m_LinkMaster2[2];				//	ڑ[ (JnEI)
	CRail *m_LinkTable[RAIL_TIP_MAX][2];	//	Ǎ̃AhXue[u
public:
	CRailList();
	~CRailList();
	bool Push(VEC3, float);
	void Pop();
	void TryLink(bool);
	void Select();
	void Release();
	void Delete();
	void SwitchAnchor();
	CRail **FindSlot();
	void ShowRail();
	void ShowLog(VEC3, float, bool);
	void EraseUser(int);
	void Cancel();
	void Finish(bool);
	CRail **Curve(CRail **, VEC3 *, VEC3 *, VEC3 *, VEC3 *, VEC3 *, VEC3 *);
	void CurveLine(VEC3 *, VEC3 *, VEC3 *, VEC3 *, VEC3 *, VEC3 *);
	void Destroy();
	void SaveData(FILE *);
	void LoadData(FILE *);
	void ReLink(CRail **);
};
