//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CRailModel.h"

//	OO[o
extern char g_BaseDir[];

//	O[o
int g_RailOptionModels = 0;					//	[vOCo^
int g_RailOptionSelect = 0;					//	Iꂽ[̃Xgԍ
CRailModel *g_RailOptionModelSeed = NULL;	//	Xg̐擪
CRailModel *g_RailOptionModelSelect = NULL;	//	Iꂽ[
CRailModel **g_RailOptionModelNext = &g_RailOptionModelSeed;
											//	Ō|C^
/*
 *	RXgN^
 */
CRailModel::CRailModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	strcpy(m_Index, str);
	if(m_Loaded = load){
		m_MeshLeft.Load("Model1.x");
		m_MeshRight.Load("Model2.x");
	}
	fscanf(info, "%s\n%s\n%f\n%f\n%f\n%f",
		m_Name, m_Author, &m_TieWidth, &m_Width, &m_Height, &m_Gauge);
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_Width *= m_Scale;
	m_Height *= m_Scale;
	m_Gauge *= RAIL_WIDTH;
	m_Next = NULL;
	*g_RailOptionModelNext = this;
	g_RailOptionModelNext = NextAdr();
	m_Count = g_RailOptionModels;
	g_RailOptionModels++;
}

/*
 *	fXgN^
 */
CRailModel::~CRailModel(){
	if(m_Next){
		delete m_Next;
		m_Next = NULL;
	}
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CObject *CRailModel::GetObject(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Rail");
		chdir(m_Index);
		m_MeshLeft.Load("Model1.x");
		m_MeshRight.Load("Model2.x");
		m_ObjectLeft.SetMesh(&m_MeshLeft, V3ZERO, 1.0f);
		m_ObjectRight.SetMesh(&m_MeshRight, V3ZERO, 1.0f);
		m_Loaded = true;
	}
	return &m_ObjectLeft;
}
