//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int STRUCT_LOG_MAX;

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CStructModel.h"

//	OO[o
extern char g_BaseDir[];
extern CLogger g_StructLog;
extern CLogger g_StructSpecLog;

//	O[o
int g_StructOptionModels = 0;					//	{݃vOCo^
int g_StructOptionSelect = 0;					//	Iꂽ{݂̃Xgԍ
int g_StructOptionListID = 0;					//	Xg\̃XN[
CStructModel *g_StructOptionModelSeed = NULL;	//	Xg̐擪
CStructModel *g_StructOptionModelSelect = NULL;	//	Iꂽ{
CStructModel **g_StructOptionModelNext = &g_StructOptionModelSeed;
												//	Ō|C^

CObject g_StructDisplayObject;	//	Tv\pIuWFNg

/*
 *	RXgN^ (X t@C쐬)
 */
CStructModel::CStructModel(
	char *str	//	X t@C
){
	if(!m_Mesh.Load(str)) ExitProcess(0);
	m_Loaded = true;
	strcpy(m_Index, "XFILE");
	strcpy(m_Name, "D3DRM-Mesh");
	strcpy(m_Author, "RSPV X-File Viewer");
	m_TieWidth = m_Mesh.m_radius*0.05f;
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_Next = NULL;
	*g_StructOptionModelNext = this;
	g_StructOptionModelNext = NextAdr();
	m_Count = g_StructOptionModels;
	g_StructOptionModels++;
}

/*
 *	RXgN^
 */
CStructModel::CStructModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	strcpy(m_Index, str);
	if(m_Loaded = load) m_Mesh.Load("Model.x");
	fscanf(info, "%s\n%s\n%f", m_Name, m_Author, &m_TieWidth);
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_Next = NULL;
	*g_StructOptionModelNext = this;
	g_StructOptionModelNext = NextAdr();
	m_Count = g_StructOptionModels;
	g_StructOptionModels++;
}

/*
 *	fXgN^
 */
CStructModel::~CStructModel(){
	if(m_Next){
		delete m_Next;
		m_Next = NULL;
	}
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CMesh *CStructModel::GetMesh(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Struct");
		chdir(m_Index);
		m_Mesh.Load("Model.x");
		m_Loaded = true;
	}
	return &m_Mesh;
}

/*
 *	Xg̍쐬
 */
void CStructModel::AddLog(
	int n	//	\JE^ (ŏ̌Ăяoɕ\ԏ̔ԍw)
){
	if(n<=0){
		if(m_Count==g_StructOptionSelect){
			g_StructLog.AddF("%s", m_Name);
			g_StructDisplayObject.SetMesh(GetMesh(), V3ZERO, m_Scale);
			g_StructOptionModelSelect = this;
			ViewSpec();
		}else{
			g_StructLog.AddF("%s", m_Name);
		}
	}
	if(n+STRUCT_LOG_MAX-4){
		if(Next()) Next()->AddLog(n-1);
		else for(; n+STRUCT_LOG_MAX-4; n--) g_StructLog.Add("");
	}
}

/*
 *	vOC̕\
 */
void CStructModel::ViewSpec(){
	g_StructSpecLog.Clear();
	g_StructSpecLog.AddF("<%s>", m_Index);
	g_StructSpecLog.Add(m_Name);
	g_StructSpecLog.AddF(": %s", m_Author);
}
