class CRail;
class CTrain;
class CTrainModel;

const int TRAIN_LINK_MAX = 64;		//	Ґqő吔
const int TRAIN_POINT_MAX = 256;	//	|Cgݒő吔
const int TRAIN_DIA_MAX = 256;		//	_COݒő吔
const int TRAIN_GROUP_MAX = 128;	//	Ґő吔

class CTrainGroup{
	friend class CTrainGroupList;
private:
	char m_Point[TRAIN_POINT_MAX];	//	|Cgݒ胊Xg
	char m_Dia[TRAIN_DIA_MAX][4];	//	|Cgݒ胊Xg
	int m_Count;					//	q
	int m_Index;					//	Ґԍ
	int m_Mode;						//	^][h
	int m_DiaNumber;				//	_Cݒ萔
	int m_DiaSelect;				//	ҏW̃_Cݒ
	int m_DiaListID;				//	Xg\̃XN[
	unsigned int m_DepartDay;		//	Ԏ ()
	unsigned int m_DepartHour;		//	Ԏ ()
	unsigned int m_DepartMin;		//	Ԏ ()
	float m_Speed;					//	݂̑x
	float m_SpeedSet;				//	ݒ葬x
	float m_SpeedMax;				//	ōx
	float m_PreviewCount;			//	vr[\W
	float m_Length;					//	Ґ
	float m_ScanDist;				//	H
	float m_StopPoint;				//	~ڕWn_
	bool m_Enabled;					//	zuĂ邩ǂ
	bool m_CabinView;				//	^]Ȏ_tO
	bool m_ClearAnchor;				//	AJ[ʉ߃tO
	CTrain *m_Car[TRAIN_LINK_MAX];	//	qXg
public:
	CTrainGroup();
	~CTrainGroup();
	void Select();
	void SetID(int);
	void AddCar(CTrainModel *, bool);
	void TurnCar();
	void PopCar();
	int GetPoint(int);
	int CountPoint();
	void AddPoint(int);
	void PopPoint();
	int ReadPoint(int);
	void ClearPoint();
	void SetDiaLog();
	int GetDiaNumber();
	int &GetDiaSelect();
	int &GetDiaListID();
	char *GetDia();
	void AddDia();
	void DeleteDia();
	void MoveDia(bool);
	void LoopDia();
	void Schedule();
	void ClearDia();
	bool Pull(CRail *, bool, bool);
	bool Set(CRail *, VEC3 *, bool);
	void Remove();
	void Show();
	void Preview();
	void ShowSpeed();
	void ShowSpeed2();
	void SetSpeed(float, int);
	float GetSpset();
	void CalcSpec();
	void SetLog();
	bool IsEnable();
	VEC3 SetCam(float, float, float);
	VEC3 SetCab();
	void Destroy();
	void SaveData(FILE *);
	void LoadData(FILE *);
};
