//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int TRAIN_LOG_MAX;
extern const float TRAIN_INTERVAL;

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CTrainModel.h"

//	OO[o
extern char g_BaseDir[];
extern CLogger g_TrainLog;
extern CLogger g_TrainSpecLog;

//	O[o
int g_TrainOptionModels = 0;					//	{݃vOCo^
int g_TrainOptionSelect = 0;					//	Iꂽ{݂̃Xgԍ
int g_TrainOptionListID = 0;					//	Xg\̃XN[
int g_TrainOptionIndex = 0;						//	IҐԍ
CTrainModel *g_TrainOptionModelSeed = NULL;		//	Xg̐擪
CTrainModel *g_TrainOptionModelSelect = NULL;	//	Iꂽ{
CTrainModel **g_TrainOptionModelNext = &g_TrainOptionModelSeed;
												//	Ō|C^

CObject g_TrainDisplayObject;	//	Tv\pIuWFNg

/*
 *	RXgN^
 */
CTrainModel::CTrainModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	strcpy(m_Index, str);
	if(m_Loaded = load) m_Mesh.Load("Model.x");
	fscanf(info, "%s\n%s\n%f\n%f\n%f\n%f", m_Name, m_Author, &m_TieWidth, &m_TireLength, &m_CarLength, &m_SpeedMax);
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_TireLength *= m_Scale;
	m_CarLength *= m_Scale;
	m_Fix = (m_CarLength-m_TireLength+TRAIN_INTERVAL)*0.5f;
	m_Next = NULL;
	*g_TrainOptionModelNext = this;
	g_TrainOptionModelNext = NextAdr();
	m_Count = g_TrainOptionModels;
	g_TrainOptionModels++;
}

/*
 *	fXgN^
 */
CTrainModel::~CTrainModel(){
	if(m_Next) delete m_Next;
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CMesh *CTrainModel::GetMesh(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Train");
		chdir(m_Index);
		m_Mesh.Load("Model.x");
		m_Loaded = true;
	}
	return &m_Mesh;
}

/*
 *	Xg̍쐬
 */
void CTrainModel::AddLog(
	int n	//	\JE^ (ŏ̌Ăяoɕ\ԏ̔ԍw)
){
	if(n<=0){
		if(m_Count==g_TrainOptionSelect){
			g_TrainLog.AddF("%s", m_Name);
			g_TrainDisplayObject.SetMesh(GetMesh(), V3ZERO, m_Scale);
			g_TrainOptionModelSelect = this;
			ViewSpec();
		}else{
			g_TrainLog.AddF("%s", m_Name);
		}
	}
	if(n+TRAIN_LOG_MAX-4){
		if(Next()) Next()->AddLog(n-1);
		else for(; n+TRAIN_LOG_MAX-4; n--) g_TrainLog.Add("");
	}
}

/*
 *	vOC̕\
 */
void CTrainModel::ViewSpec(){
	g_TrainSpecLog.Clear();
	g_TrainSpecLog.AddF("<%s>", m_Index);
	g_TrainSpecLog.Add(m_Name);
	g_TrainSpecLog.AddF(": %s", m_Author);
	g_TrainSpecLog.AddF("ōx: %.2f", m_SpeedMax);
	g_TrainSpecLog.AddF("ԑ̒: %.2f", m_CarLength);
}
