//	Cu
#include <stdio.h>
#include <direct.h>

//	OO[o
extern char g_BaseDir[];
extern int g_MiscOptionShadowFlag;
extern int g_MiscOptionTieFlag;
extern int g_MiscOptionLineFlag;
extern int g_MiscOptionRailMode;
extern int g_MiscOptionTrainMode;
extern int g_MiscOptionStationMode;
extern int g_MiscOptionStructMode;
extern int g_MiscOptionTexFilter;
extern int g_MiscOptionProjectionMode;
extern int g_MiscOptionEarthSpinFlag;
extern int g_MiscOptionFontShadowFlag;
extern int g_MiscOptionMagnetFlag;
extern int g_MiscOptionWindowFlag;
extern int g_MiscOptionDispSize;
extern int g_MiscOptionPluginSort;
extern int g_MiscOptionUseUndo;
extern int g_VideoFrame;
extern int g_PictureCount;

//	O[o
int g_DisplayOptionWidth;	//	𑜓x x
int g_DisplayOptionHeight;	//	𑜓x y

/*
 *	ݒǍ
 */
void LoadOption(){
	static const int wtable[3] = {640, 800, 1024};
	static const int htable[3] = {480, 600, 768};
	FILE *fname;
	chdir(g_BaseDir);
	if(fname = fopen("RailSim.cfg", "r")){
		fscanf(fname, "RenderShadow=%d\n", &g_MiscOptionShadowFlag);
		fscanf(fname, "RenderTie=%d\n", &g_MiscOptionTieFlag);
		fscanf(fname, "RenderLine=%d\n", &g_MiscOptionLineFlag);
		fscanf(fname, "RenderRail=%d\n", &g_MiscOptionRailMode);
		fscanf(fname, "RenderTrain=%d\n", &g_MiscOptionTrainMode);
		fscanf(fname, "RenderStation=%d\n", &g_MiscOptionStationMode);
		fscanf(fname, "RenderStruct=%d\n", &g_MiscOptionStructMode);
		fscanf(fname, "TextureFilter=%d\n", &g_MiscOptionTexFilter);
		fscanf(fname, "Projection=%d\n", &g_MiscOptionProjectionMode);
		fscanf(fname, "EarthSpin=%d\n", &g_MiscOptionEarthSpinFlag);
		fscanf(fname, "FontShadow=%d\n", &g_MiscOptionFontShadowFlag);
		fscanf(fname, "Magnet=%d\n", &g_MiscOptionMagnetFlag);
		fscanf(fname, "Window=%d\n", &g_MiscOptionWindowFlag);
		fscanf(fname, "DispSize=%d\n", &g_MiscOptionDispSize);
		fscanf(fname, "PluginSort=%d\n", &g_MiscOptionPluginSort);
		fscanf(fname, "UseUndo=%d\n", &g_MiscOptionUseUndo);
		fclose(fname);
	}
	g_DisplayOptionWidth = wtable[g_MiscOptionDispSize];
	g_DisplayOptionHeight = htable[g_MiscOptionDispSize];
}

/*
 *	ݒۑ
 */
void SaveOption(){
	FILE *fname;
	chdir(g_BaseDir);
	if(fname = fopen("RailSim.cfg", "w")){
		fprintf(fname, "RenderShadow=%d\n", g_MiscOptionShadowFlag);
		fprintf(fname, "RenderTie=%d\n", g_MiscOptionTieFlag);
		fprintf(fname, "RenderLine=%d\n", g_MiscOptionLineFlag);
		fprintf(fname, "RenderRail=%d\n", g_MiscOptionRailMode);
		fprintf(fname, "RenderTrain=%d\n", g_MiscOptionTrainMode);
		fprintf(fname, "RenderStation=%d\n", g_MiscOptionStationMode);
		fprintf(fname, "RenderStruct=%d\n", g_MiscOptionStructMode);
		fprintf(fname, "TextureFilter=%d\n", g_MiscOptionTexFilter);
		fprintf(fname, "Projection=%d\n", g_MiscOptionProjectionMode);
		fprintf(fname, "EarthSpin=%d\n", g_MiscOptionEarthSpinFlag);
		fprintf(fname, "FontShadow=%d\n", g_MiscOptionFontShadowFlag);
		fprintf(fname, "Magnet=%d\n", g_MiscOptionMagnetFlag);
		fprintf(fname, "Window=%d\n", g_MiscOptionWindowFlag);
		fprintf(fname, "DispSize=%d\n", g_MiscOptionDispSize);
		fprintf(fname, "PluginSort=%d\n", g_MiscOptionPluginSort);
		fprintf(fname, "UseUndo=%d\n", g_MiscOptionUseUndo);
		fclose(fname);
	}
}
