//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"

//	NX
#include "CInterface.h"
#include "CInterfaceButton.h"

//	OO[o
extern POINT g_Pointer;

/*
 *	RXgN^
 */
CInterfaceButton::CInterfaceButton(
	char *s,	//	x
	int x,		//	x W
	int y,		//	y W
	int w,		//	
	int h,		//	
	D3DCOLOR c	//	F
):
	CInterface(x, y, w, h, c)	//	{NX
{
	SetCaptionArea(0, 0, m_Width, m_Height);
	SetCaption(s);
	m_LastDown = false;
}

/*
 *	_O
 *
 *	߂l:	{^NbNA}EX̃{^ꂽƂ true Ԃ
 */
bool CInterfaceButton::Render(){
	bool pull = GetButton(DIM_LEFT)==S_PULL;
	if(m_Enabled && CheckRect(g_Pointer.x, g_Pointer.y, m_PosX, m_PosY, m_Width, m_Height)){
		if(GetButton(DIM_LEFT)==S_PUSH) m_LastDown = true;
		if(m_LastDown){
			Draw2DRect(m_PosX-2, m_PosY-2, m_PosX+m_Width+1, m_PosY+m_Height+1, 0xffffffff);
			Grad2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, m_ShadowColor, m_Color, m_Color, m_ShadowColor);
		}else{
			Draw2DRect(m_PosX-2, m_PosY-2, m_PosX+m_Width+1, m_PosY+m_Height+1, 0xff808080);
			Grad2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, m_DarkColor, m_ShadowColor, m_ShadowColor, m_DarkColor);
		}
		Text(m_CapPosX, m_CapPosY, m_Caption);
		if(m_LastDown && pull){
			m_LastDown = false;
			return true;
		}
		return false;
	}
	if(pull) m_LastDown = false;
	if(m_LastDown){
		Draw2DRect(m_PosX-2, m_PosY-2, m_PosX+m_Width+1, m_PosY+m_Height+1, 0xffffffff);
		Grad2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, m_DarkColor, m_ShadowColor, m_ShadowColor, m_DarkColor);
	}else{
		Grad2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, m_DarkShadow, m_DarkColor, m_DarkColor, m_DarkShadow);
	}
	Text(m_CapPosX, m_CapPosY, m_Caption);
	return false;
}
