//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"

//	NX
#include "CInterface.h"
#include "CInterfaceCheck.h"

//	OO[o
extern POINT g_Pointer;

/*
 *	RXgN^
 */
CInterfaceCheck::CInterfaceCheck(
	char *s,				//	x
	int x,					//	x W
	int y,					//	y W
	int w,					//	
	int h,					//	
	D3DCOLOR c,				//	F
	CInterfaceCheck *master	//	}X^[
):
	CInterface(x, y, w, h, c)	//	{NX
{
	SetCaptionArea(m_Height+5, 0, 0, m_Height);
	SetCaption(s);
	m_LastDown = false;
	if(m_Master = master){
		m_Index = m_Master->m_Number;
		m_Master->m_Number++;
	}else{
		m_Index = 0;
	}
	m_Number = 1;
	m_Value = 0;
}

/*
 *	_O
 */
void CInterfaceCheck::Render(){
	bool pull = GetButton(DIM_LEFT)==S_PULL;
	bool same = m_Master ? m_Master->m_Value==m_Index : m_Value==m_Index;
	if(m_Enabled && CheckRect(g_Pointer.x, g_Pointer.y, m_PosX, m_PosY, m_Width, m_Height)){
		if(GetButton(DIM_LEFT)==S_PUSH) m_LastDown = true;
		Fill2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, 0xc0000000);
		if(m_LastDown){
			Fill2DRect(m_PosX+1, m_PosY+1, m_PosX+m_Height-1, m_PosY+m_Height-1, 0xffffffff);
			Grad2DRect(m_PosX+2, m_PosY+2, m_PosX+m_Height-2, m_PosY+m_Height-2, m_ShadowColor, m_Color, m_ShadowColor, m_DarkColor);
			if(same){
				Draw2DLine(m_PosX+1, m_PosY+1, m_PosX+m_Height-2, m_PosY+m_Height-2, 0xffffffff, 0xffffffff);
				Draw2DLine(m_PosX+1, m_PosY+m_Height-2, m_PosX+m_Height-2, m_PosY+1, 0xffffffff, 0xffffffff);
			}
			if(pull){
				m_LastDown = false;
				(m_Master ? m_Master : this)->m_Value = m_Index;
			}
		}else{
			Fill2DRect(m_PosX+1, m_PosY+1, m_PosX+m_Height-1, m_PosY+m_Height-1, 0xffc0c0c0);
			Grad2DRect(m_PosX+2, m_PosY+2, m_PosX+m_Height-2, m_PosY+m_Height-2, m_ShadowColor, m_Color, m_ShadowColor, m_DarkColor);
			if(same){
				Draw2DLine(m_PosX+1, m_PosY+1, m_PosX+m_Height-2, m_PosY+m_Height-2, 0xffc0c0c0, 0xffc0c0c0);
				Draw2DLine(m_PosX+1, m_PosY+m_Height-2, m_PosX+m_Height-2, m_PosY+1, 0xffc0c0c0, 0xffc0c0c0);
			}
		}
		Text(m_CapPosX, m_CapPosY, m_Caption);
		return;
	}
	if(pull) m_LastDown = false;
	Fill2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, 0xc0000000);
	if(m_LastDown){
		Fill2DRect(m_PosX+1, m_PosY+1, m_PosX+m_Height-1, m_PosY+m_Height-1, 0xffffffff);
		Grad2DRect(m_PosX+2, m_PosY+2, m_PosX+m_Height-2, m_PosY+m_Height-2, m_DarkColor, m_ShadowColor, m_DarkColor, m_DarkShadow);
		if(same){
			Draw2DLine(m_PosX+1, m_PosY+1, m_PosX+m_Height-2, m_PosY+m_Height-2, 0xffffffff, 0xffffffff);
			Draw2DLine(m_PosX+1, m_PosY+m_Height-2, m_PosX+m_Height-2, m_PosY+1, 0xffffffff, 0xffffffff);
		}
	}else{
		Fill2DRect(m_PosX+1, m_PosY+1, m_PosX+m_Height-1, m_PosY+m_Height-1, 0xff808080);
		Grad2DRect(m_PosX+2, m_PosY+2, m_PosX+m_Height-2, m_PosY+m_Height-2, m_DarkColor, m_ShadowColor, m_DarkColor, m_DarkShadow);
		if(same){
			Draw2DLine(m_PosX+1, m_PosY+1, m_PosX+m_Height-2, m_PosY+m_Height-2, 0xff808080, 0xff808080);
			Draw2DLine(m_PosX+1, m_PosY+m_Height-2, m_PosX+m_Height-2, m_PosY+1, 0xff808080, 0xff808080);
		}
	}
	Text(m_CapPosX, m_CapPosY, m_Caption);
}

/*
 *	Ԃ̃Zbg
 */
void CInterfaceCheck::Reset(){
	m_Value = 0;
}

/*
 *	߂l: O[vőIĂ`FbN{bNXԍ
 */
int CInterfaceCheck::GetValue(){
	return m_Value;
}
