//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"

//	NX
#include "CInterface.h"
#include "CInterfaceSlider.h"

//	OO[o
extern POINT g_Pointer;

/*
 *	RXgN^
 */
CInterfaceSlider::CInterfaceSlider(
	char *s,	//	x
	int x,		//	x W
	int y,		//	y W
	int w1,		//	x̕
	int w2,		//	XC_̕
	int w3,		//	l\̕
	int h,		//	
	D3DCOLOR c,	//	F
	int min,	//	ŏl
	int max,	//	ől
	int *list,	//	`lgpꍇ̐lXg
	int col,	//	ڐ
	int init	//	I
):
	CInterface(x, y, 0, h, c)	//	{NX
{
	m_Width1 = w1; m_Width2 = w2; m_Width3 = w3;
	m_Width = m_Width1+m_Width2+m_Width3;
	SetCaptionArea(0, 0, m_Width1, m_Height);
	SetCaption(s);
	m_Min = min; m_Max = max; m_List = list; m_Column = col;
	SetValue(m_Init = init);
	m_SliderOffset = m_PosX+m_Width1+m_Height/2;
	m_SliderWidth = m_Width2-m_Height;
	m_HandleWidth = m_SliderWidth/m_Column;
	m_LastDown = false;
}

/*
 *	_O
 */
void CInterfaceSlider::Render(){
	D3DCOLOR lc1, lc2;
	int tmpx = m_SliderOffset+m_SliderWidth*m_Index/m_Column;
	bool rectin = CheckRect(g_Pointer.x, g_Pointer.y, m_PosX, m_PosY, m_Width, m_Height);
	if(m_Enabled && rectin){
		if(GetButton(DIM_LEFT)==S_PUSH) m_LastDown = true;
		if(m_LastDown){
			lc1 = 0x00ffffff; lc2 = 0xffffffff;
			SetValue((g_Pointer.x-m_SliderOffset)*m_Column/m_SliderWidth);
		}else{
			lc1 = 0x00c0c0c0; lc2 = 0xffc0c0c0;
		}
	}else{
		if(m_LastDown){
			lc1 = 0x00ffffff; lc2 = 0xffffffff;
		}else{
			lc1 = 0x00808080; lc2 = 0xff808080;
		}
	}
	if(GetButton(DIM_LEFT)<=S_PULL) m_LastDown = false;
	Fill2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, 0xc0000000);
	Draw2DLine(m_PosX+m_Width1, m_PosY+m_Height-2, m_PosX, m_PosY+m_Height-2, lc2, lc1);
	Draw2DLine(m_PosX+m_Width1, m_PosY+m_Height-2, m_PosX+m_Width1+m_Height/2-1, m_PosY+m_Height/2-1, lc2, lc2);
	Draw2DLine(m_PosX+m_Width1+m_Width2-m_Height/2, m_PosY+m_Height/2-1, m_PosX+m_Width1+m_Height/2-1, m_PosY+m_Height/2-1, lc2, lc2);
	Draw2DLine(m_PosX+m_Width1+m_Width2-1, m_PosY+m_Height-2, m_PosX+m_Width1+m_Width2-m_Height/2, m_PosY+m_Height/2-1, lc2, lc2);
	Draw2DLine(m_PosX+m_Width1+m_Width2-1, m_PosY+m_Height-2, m_PosX+m_Width, m_PosY+m_Height-2, lc2, lc1);
	Fill2DRect(tmpx, m_PosY+1, tmpx+m_HandleWidth, m_PosY+m_Height-1, lc2);
	if(rectin) Grad2DRect(tmpx+1, m_PosY+2, tmpx+m_HandleWidth-1, m_PosY+m_Height-2, m_ShadowColor, m_Color, m_ShadowColor, m_DarkColor);
	else Grad2DRect(tmpx+1, m_PosY+2, tmpx+m_HandleWidth-1, m_PosY+m_Height-2, m_DarkColor, m_ShadowColor, m_DarkColor, m_DarkShadow);
	Text(m_CapPosX, m_CapPosY, m_Caption);
	Text(m_ValCapPosX, m_CapPosY, m_ValueCaption);
}

/*
 *	Zbg
 */
void CInterfaceSlider::Reset(){
	SetValue(m_Init);
}

/*
 *	l̐ݒƐlx̏
 */
void CInterfaceSlider::SetValue(int v){
	m_Index = v;
	ValueArea(&m_Index, 0, m_Column-1);
	sprintf(m_ValueCaption, "%d", GetValue());
	m_ValCapPosX = m_PosX+m_Width1+m_Width2+(m_Width3-FONT_WIDTH*strlen(m_ValueCaption))/2;
}

/*
 *	߂l: ݒ萔l
 */
int CInterfaceSlider::GetValue(){
	return m_List ? m_List[m_Index] : (m_Max-m_Min)*m_Index/(m_Column-1)+m_Min;
}
