//	Cu
#include "lib\udx.h"

/*
 *	XN[Wn (POINT) ւ̕ϊ
 *
 *	߂l: XN[W
 */
POINT WorldToScreen2(
	VEC3 *w	//	[hW
){
	VEC3 st;
	POINT scr;
	st = WorldToScreen(*w);
	scr.x = (int)(st.x);
	scr.y = (int)(st.y);
	return scr;
}

/*
 *	D3DCOLOR  int lɕ
 */
void SplitColor(
	int *a,		//	a li[
	int *r,		//	r li[
	int *g,		//	g li[
	int *b,		//	b li[
	D3DCOLOR c	//	F
){
	if(a) *a = (c&0xff000000)>>24;
	if(r) *r = (c&0x00ff0000)>>16;
	if(g) *g = (c&0x0000ff00)>>8;
	if(b) *b = c&0x000000ff;
}

/*
 *	`Of[V̕`
 */
void Grad2DRect(
	int x1,			//	 x
	int y1,			//	 y
	int x2,			//	E x
	int y2,			//	E y
	D3DCOLOR c1,	//	F
	D3DCOLOR c2,	//	F
	D3DCOLOR c3,	//	EF
	D3DCOLOR c4		//	EF
){
	VTX_TL vt[] = {
		x1, y2, 0.0, 1.0, c1,
		x1, y1, 0.0, 1.0, c2,
		x2, y1, 0.0, 1.0, c3,
		x2, y2, 0.0, 1.0, c4};
	CVertex v;
	v.Create(vt, FVF_TL, sizeof(vt));
	v.RenderTF(2);
}

/*
 *	tbZ[WŃ_CAO̕\
 */
void Dialog(
	char *format,	//	
	...				//	Cӈ
){
	char mes[1024];
	va_list	vl;
	va_start(vl,format);
	vsprintf(mes,format,vl);
	va_end(vl);
	MessageBox(GetActiveWindow(), mes, "RailSim", MB_APPLMODAL);
}

/*
 *	t^CgLvVݒ
 */
void SetCaption2(
	char *format,	//	
	...				//	Cӈ
){
	char mes[1024];
	va_list	vl;
	va_start(vl,format);
	vsprintf(mes,format,vl);
	va_end(vl);
	SetCaption(mes);
}
