//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#define MESH_W 20 //bV̕
#define MESH_H 20

class CWaterMesh
{
	CVertex m_vtx; //_obt@
	VTX_LX  m_vt[MESH_H * MESH_W * 6];	//_e[u

	VEC2 m_cuv[MESH_H+1][MESH_W+1];	//UVItZbg
	VEC2 m_ouv[MESH_H+1][MESH_W+1];	//Pt[OUVItZbg
	VEC2 m_vec[MESH_H+1][MESH_W+1];	//UVωx

	VEC3  m_pos;	//ʒu
	float m_w;		//
	float m_h;		//c
	float m_dw;		//P}X̉
	float m_dh;		//P}X̏c
	float m_speed;	//UVωx̏Z
	float m_gain;	//ij
	D3DCOLOR m_color;	//F

	//Rs[RXgN^
	CWaterMesh& operator = (const CWaterMesh&){return *this;}
public:
	CWaterMesh();
	~CWaterMesh();
	void Init(VEC3 pos,float w,float h,float d);
	void Render();
	void Impact(float x,float y,float d);

	/*============================================================================
	  F̐ݒ
	============================================================================*/
	void SetColor(D3DCOLOR c)
	{m_color = c;}
	/*============================================================================
	  F̎擾
	============================================================================*/
	D3DCOLOR GetColor()
	{return m_color;}
	/*============================================================================
	  x̐ݒ
	============================================================================*/
	void SetSpeed(float speed)
	{m_speed = speed; if(m_speed < 0) m_speed = 0;}
	/*============================================================================
	  x̎擾
	============================================================================*/
	float GetSpeed()
	{return m_speed;}
	/*============================================================================
	  ij̐ݒ
	============================================================================*/
	void SetGain(float b)
	{m_gain = b;}
	/*============================================================================
	  ij̎擾
	============================================================================*/
	float GetGain()
	{return m_gain;}
};