//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
class CXFile
{
	LPDIRECTXFILE			m_pXF;
	LPDIRECTXFILEENUMOBJECT	m_pPtr;

public:
	CXFile();
	~CXFile();
	BOOL Open(LPCSTR strSrc,BOOL fRes=FALSE);
	BOOL GetNextData(LPDIRECTXFILEDATA* ppDat);
	BOOL GetTopMesh(LPDIRECTXFILEDATA* ppDat);
	void Close();
};

class CMesh
{
	LPD3DXMESH		m_pMesh;	//bV{
	D3DMATERIAL8*	m_pMat;		//}eAXg
	D3DMATERIAL8*	m_pMat2;
	int*			m_pMatOrder;
	LPTEX8*			m_pTex;		//eNX`Xg
	DWORD			m_dwNumMat;	//}eA
	std::string		m_strName;	//t@C

	static CTexList s_texList;	//eNX`Xgiʁj

	//Rs[RXgN^
	CMesh& operator = (const CMesh&){return *this;}
public:
	VEC3	m_min;		//E{bNX
	VEC3	m_max;		//E{bNX
	VEC3	m_center;	//E̒S
	float	m_radius;	//E̔a

	CMesh();
	//CMesh(CMesh& src);
	~CMesh();

	BOOL Load(char* strFile,D3DCOLOR cTrans=0,int nMipLv=1);
	BOOL LoadResource(char* strRes,D3DCOLOR cTrans=0,int nMipLv=1);
	BOOL CreateSphere(float r,UINT sl,UINT st,D3DCOLORVALUE cv);
	BOOL CreateBox(float x,float y,float z,D3DCOLORVALUE cv);
	BOOL CreateTeapot(D3DCOLORVALUE cv);
	void Free();
	void ComputeBoundary();

	void Render(MTX4* pMtx);
	void RenderT(MTX4* pMtx,LPTEX8 pTex);
	void RenderA(MTX4* pMtx,float alpha);
	void RenderAP(MTX4* pMtx,float aplus);
	void RenderSC(MTX4* pMtx,D3DMATERIAL8* pMat);

	/*============================================================================
	  IuWFNg̎擾
	============================================================================*/
	LPD3DXMESH GetObject()
	{return m_pMesh;}
};
