//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#define STREAM_TIMEOUT	INFINITE
#define THREAD_TIMEOUT	1000

//Xg[~OĐǗ
class CWaveStream
{
	LPSNDBUF	m_pBuf;		//Xg[obt@
	LPSNDNOTIFY	m_pNotify;	//Đisx̒ʒmIuWFNg
	HANDLE		m_hEvent;	//Đisx̒ʒmCxg
	DWORD		m_size;		//obt@TCY
	DWORD		m_wpos;		//obt@݈ʒu

	//Rs[RXgN^
	CWaveStream& operator = (const CWaveStream&){return *this;}
public:
	CWaveStream();
	~CWaveStream();

	BOOL Begin(LPWAVEFORMATEX format,DWORD size,int count);
	void End();
	BOOL Enqueue(LPBYTE pData,DWORD size);
};

//XbhǗ
class CThread
{
public:
	DWORD	m_idThread;
	HANDLE	m_hThread;

	/*============================================================================
	  RXgN^
	============================================================================*/
	CThread()
	{
		m_hThread = NULL;
	}
	/*============================================================================
	  fXgN^
	============================================================================*/
	~CThread()
	{
		End();
	}
	/*============================================================================
	  Xbh쐬
	============================================================================*/
	BOOL Begin(LPTHREAD_START_ROUTINE func,void* pData)
	{
		m_hThread = CreateThread(NULL, 0, func, pData, 0, &m_idThread);

		if(m_hThread == NULL)
		{
			Debug("CreateThread\n");
			return FALSE;
		}
		return TRUE;
	}
	/*============================================================================
	  Xbh
	============================================================================*/
	void End(DWORD timeout=THREAD_TIMEOUT)
	{
		if(m_hThread)
		{
			if(WaitForSingleObject(m_hThread, timeout) == WAIT_TIMEOUT)
			{
				//^CAEg狭I
				Debug("time out CThread::End\n");
				TerminateThread(m_hThread,0);
			}
			CloseHandle(m_hThread);
			m_hThread = NULL;
		}
	}
};